<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.6.0) on Sun Jun 10 11:40:16 CEST 2007 -->
<TITLE>
JavaSciWrapper
</TITLE>

<META NAME="date" CONTENT="2007-06-10">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="JavaSciWrapper";
    }
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">
<HR>


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/JavaSciWrapper.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../javasciplugin/ElementFactory.html" title="class in javasciplugin"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../javasciplugin/Observer.html" title="interface in javasciplugin"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../index.html?javasciplugin/JavaSciWrapper.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="JavaSciWrapper.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
javasciplugin</FONT>
<BR>
Class JavaSciWrapper</H2>
<PRE>
java.lang.Object
  <IMG SRC="../resources/inherit.gif" ALT="extended by "><B>javasciplugin.JavaSciWrapper</B>
</PRE>
<HR>
<DL>
<DT><PRE>public class <B>JavaSciWrapper</B><DT>extends java.lang.Object</DL>
</PRE>

<P>
This class is a wrapper class for the access to Scilab functions. It is the main connection between the plugin and the Scilab engine.
 The methods are all synchronized to prevent deadlocks when multiple plugin widgets access the wrapper at the same time.
 The main methods are loadHistory, loadSciWorkspace and exec.
<P>

<P>
<HR>

<P>

<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../javasciplugin/JavaSciWrapper.html#JavaSciWrapper()">JavaSciWrapper</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The constructor initialises the Scilab variables.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../javasciplugin/JavaSciWrapper.html#addObserver(javasciplugin.Observer)">addObserver</A></B>(<A HREF="../javasciplugin/Observer.html" title="interface in javasciplugin">Observer</A>&nbsp;o)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This method adds an observer to the list of observers that are notified when a command is executed.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../javasciplugin/JavaSciWrapper.html#dispose()">dispose</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This method is called by the Activator when it is closed.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.Vector</CODE></FONT></TD>
<TD><CODE><B><A HREF="../javasciplugin/JavaSciWrapper.html#exec(java.lang.String)">exec</A></B>(java.lang.String&nbsp;pCommand)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This method executes a command that is passed as parameter and returns a Vector that contains the output of this command.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.Enumeration</CODE></FONT></TD>
<TD><CODE><B><A HREF="../javasciplugin/JavaSciWrapper.html#getHistory()">getHistory</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This method returns the history from the history Vector.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.lang.String</CODE></FONT></TD>
<TD><CODE><B><A HREF="../javasciplugin/JavaSciWrapper.html#getHistoryElement(int, java.lang.String)">getHistoryElement</A></B>(int&nbsp;index,
                  java.lang.String&nbsp;startingString)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This method returns a command from the history.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.concurrent.Semaphore</CODE></FONT></TD>
<TD><CODE><B><A HREF="../javasciplugin/JavaSciWrapper.html#getPlotSemaphor()">getPlotSemaphor</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This method returns a semaphore that is used with the plot function.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.Vector</CODE></FONT></TD>
<TD><CODE><B><A HREF="../javasciplugin/JavaSciWrapper.html#getSciWorkspace()">getSciWorkspace</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This method returns the workspace Vector witch contains the current user defined variables by there name, first value, type and size.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../javasciplugin/JavaSciWrapper.html#loadSciHistory()">loadSciHistory</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This method fills a global String Vector with the command history that is saved in two different places.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../javasciplugin/JavaSciWrapper.html#loadSciWorkspace()">loadSciWorkspace</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This method loads the current workspace from the Scilab engine.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.Object</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="JavaSciWrapper()"><!-- --></A><H3>
JavaSciWrapper</H3>
<PRE>
public <B>JavaSciWrapper</B>()</PRE>
<DL>
<DD>The constructor initialises the Scilab variables. 
All the Scilab variables that are may be needed by the plugin are initialised.
Furthermore the observer vector is initialised. 
This vector contains all the views that need to be notified when a command is executed (history, workspace).
<P>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="loadSciHistory()"><!-- --></A><H3>
loadSciHistory</H3>
<PRE>
public void <B>loadSciHistory</B>()</PRE>
<DL>
<DD>This method fills a global String Vector with the command history that is saved in two different places.
The two files are the Scilab history and a history file that is located in the working directory of the plugin.
Furthermore the size of the Scilab history is saved.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getHistory()"><!-- --></A><H3>
getHistory</H3>
<PRE>
public java.util.Enumeration <B>getHistory</B>()</PRE>
<DL>
<DD>This method returns the history from the history Vector.
 The history is loaded into the history Vector with the method loadHistory.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>an Enumeration that contains the history from the history Vector.</DL>
</DD>
</DL>
<HR>

<A NAME="getHistoryElement(int, java.lang.String)"><!-- --></A><H3>
getHistoryElement</H3>
<PRE>
public java.lang.String <B>getHistoryElement</B>(int&nbsp;index,
                                          java.lang.String&nbsp;startingString)</PRE>
<DL>
<DD>This method returns a command from the history. This command is identified by an index and a starting string.
If the starting string is empty then the element of the history Vector at the position of the index is returned. 
Else only the elements with the particular starting string at there beginning are considered.
Furthermore the index will than identifies the n's command with this starting string.
This method is used by the console when the arrows up and down are pressed.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>index</CODE> - is the n's occurrence of a command with a particular starting string<DD><CODE>startingString</CODE> - is the string with what a element of the history Vector must start
<DT><B>Returns:</B><DD>a string from the history Vector which starts with the startingString and is the n's occurrence in the history.</DL>
</DD>
</DL>
<HR>

<A NAME="addObserver(javasciplugin.Observer)"><!-- --></A><H3>
addObserver</H3>
<PRE>
public void <B>addObserver</B>(<A HREF="../javasciplugin/Observer.html" title="interface in javasciplugin">Observer</A>&nbsp;o)</PRE>
<DL>
<DD>This method adds an observer to the list of observers that are notified when a command is executed.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>o</CODE> - is an instance of a class that implements the interface Observer (HistoryWidget and workspaceWidget)</DL>
</DD>
</DL>
<HR>

<A NAME="dispose()"><!-- --></A><H3>
dispose</H3>
<PRE>
public void <B>dispose</B>()</PRE>
<DL>
<DD>This method is called by the Activator when it is closed. It sends a close signal to the plot thread.
 Furthermore it saves the command that are not in the Scilab history to a file inside the plugin working directory because the plugin can not add commands to the Scilab history.
 In the end it closed the Scilab engine.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getPlotSemaphor()"><!-- --></A><H3>
getPlotSemaphor</H3>
<PRE>
public java.util.concurrent.Semaphore <B>getPlotSemaphor</B>()</PRE>
<DL>
<DD>This method returns a semaphore that is used with the plot function.
 The plot function must not be used in parallel with the loadSciWorkspace method otherwise a xlib error may occur.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>a semaphore that is used in with the plot function</DL>
</DD>
</DL>
<HR>

<A NAME="loadSciWorkspace()"><!-- --></A><H3>
loadSciWorkspace</H3>
<PRE>
public void <B>loadSciWorkspace</B>()</PRE>
<DL>
<DD>This method loads the current workspace from the Scilab engine.
 The currently user allocated variables are saved with there name, value (first element of the array), type and size in the workspace Vector.
 THis method is executed at the initialisation and at every command execution, except when this command is a plot command. The plot command and the workspace command are mu not be used in parallel.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getSciWorkspace()"><!-- --></A><H3>
getSciWorkspace</H3>
<PRE>
public java.util.Vector <B>getSciWorkspace</B>()</PRE>
<DL>
<DD>This method returns the workspace Vector witch contains the current user defined variables by there name, first value, type and size.
 The Vector is filled with the loadSciWorkspace method.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the workspace Vector witch contains the current user defined variables by there name, first value, type and size</DL>
</DD>
</DL>
<HR>

<A NAME="exec(java.lang.String)"><!-- --></A><H3>
exec</H3>
<PRE>
public java.util.Vector <B>exec</B>(java.lang.String&nbsp;pCommand)</PRE>
<DL>
<DD>This method executes a command that is passed as parameter and returns a Vector that contains the output of this command. This method is used by the console.
 The command is normally executed with the string function of Scilab. This makes it possible to save the output of the command in a matrix of strings. 
 However some commands do not work with the string function: clear, exec, multiple lined commands, =, plot and the visualisation functions of Scilab: disp, printf.
 The plot is executed in a separate thread of the type Plot. A multiple lined command is temporary saved in a file and this file is executed as a normal script.
 After the execution of the command the result formated so that the digits are placed one below each other in a matrix.
 This formatted text is saved in the return Vector.
 Known restriction: plot command can not be used in a script.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>pCommand</CODE> - is the command that should be executed.
<DT><B>Returns:</B><DD>a Vector that contains the output of a command.</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/JavaSciWrapper.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../javasciplugin/ElementFactory.html" title="class in javasciplugin"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../javasciplugin/Observer.html" title="interface in javasciplugin"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../index.html?javasciplugin/JavaSciWrapper.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="JavaSciWrapper.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
